# README for dataport-schuposh-acls

This package contains custom ACLs for school portal SH.

## conffiles/etc/ldap/slapd.conf.d/65dataport-schuposh-acls

This UCR template becomes part of `/etc/ldap/slapd.conf`
It contains the actual slapd ACLs and some logic to get all ucs@school administrator groups from LDAP.
The ACLs itself are defined by the customer.

### ACL overview

| description                                | group (uniqueMember)         | access                                                                                  |
|--------------------------------------------|------------------------------|-----------------------------------------------------------------------------------------|
| delegate portal settings to FVM            | dataport-schuposh-fvm-admins | write to cn=univention,cn=portals,${ldap_base} (UCS5) or cn=portal,cn=univention (UCS4) |
| do not show groups outside school OUS      | iqsh-admins                  | none to all groups except cn=admins- & cn=Domain Users                                  |
| do not show builtin groups                 | iqsh-admins                  | none to cn=Builtin                                                                      |
| Access to temporary objects                | iqsh-admins                  | write to cn=temporary,cn=univention,${ldap_base}                                        |
| Grant access to user management below OUs  | iqsh-admins                  | write to cn=users,ou=(.+,),${ldap_base}                                                 |
| Grant access to group management below OUs | iqsh-admins                  | write to cn=groups,ou=(.+,),${ldap_base}                                                |
| Grant access to ou admins                  | iqsh-admins                  | write to cn=ouadmins,cn=groups,${ldap_base}                                             |
| Grant access to import admins              | iqsh-admins                  | write to cn=import_admins-(.+,),cn=groups,ou=(.*,),${ldap_base}                         |

## conffiles/etc/dataport-schuposh-acls

This script is being executed by the listener module `dataport-schuposh-acls.py` and will also be run when one of the variables specified in `dataport-schuposh-acls/debian/dataport-schuposh-acls.univention-config-registry` is being changed.
It executes an UCR commit of `/etc/ldap/slapd.conf` and restarts `slapd`

## usr/bin/remove_import_permissions_from_admin_groups.sh

This script removes permissions from LDAP, namely import permissions from admin-<school> groups, which the customers wanted at an earlier stage of the project.

## usr/lib/univention-directory-listener/system/dataport-schuposh-acls.py

This listener module is being run on every school creation and is responsible for:

* Adding import permissions for this school to cn=iqsh-admins,cn=groups,$ldap_base
* Creating a import_admins-<school> group with import permissions for students and teachers for the school

